<?php
use Symfony\Component\HttpFoundation\HeaderUtils;
namespace msta\emailontopic\controller;
class main {
  protected $phpbb_container;
  protected $config;
  protected $user;
  protected $db;
  protected $request;
  protected $auth;
  protected $phpbb_dispatcher;
  protected $language;
  protected $phpbb_root_path;
  private $table_prefix;
 
  public function __construct ($phpbb_container, \phpbb\config\config $config, \phpbb\user $user, \phpbb\db\driver\driver_interface $db, \phpbb\request\request $request, \phpbb\auth\auth $auth, \phpbb\event\dispatcher_interface $phpbb_dispatcher, \phpbb\language\language $language, $phpbb_root_path) {
    $this->phpbb_container = $phpbb_container;
    $this->config = $config;
    $this->user = $user;
    $this->db = $db;
    $this->request = $request;
    $this->auth = $auth;
    $this->phpbb_dispatcher = $phpbb_dispatcher;
    $this->language = $language;
    $this->phpbb_root_path = $phpbb_root_path;
    $this->table_prefix = substr(USERS_TABLE, 0, -5);
  }

  private function getMailMessenger () {
    return \msta\emailontopic\includes\bridges\MailMessenger::getInstance($this->phpbb_container, $this->db, $this->config, $this->phpbb_dispatcher, $this->phpbb_root_path);
  }

  private function getTelegramBridge () {
    return \msta\emailontopic\includes\bridges\TelegramBridge::getInstance($this->phpbb_container, $this->db, $this->config, $this->phpbb_dispatcher, $this->phpbb_root_path);
  }

  private function getPermissionCheck () {
    return \msta\emailontopic\includes\PermissionCheck::getInstance($this->db, $this->auth);
  }

  private function permissionString () {
    if ($this->request->variable('user_name', '') != '') {
      $existingRow = $this->db->sql_fetchrow($this->db->sql_query('SELECT user_id FROM '.$this->table_prefix."users WHERE username = '".$this->db->sql_escape($this->request->variable('user_name', ''))."'"));
      if ($existingRow) {
        $this->getPermissionCheck()->initAddressingPermissions($this->user->data['user_id'], array(array(
          'uid' => intval($existingRow['user_id']),
          'name' => $this->request->variable('user_name', ''),
        )), array(), true);
        $access = $this->getPermissionCheck()->userCanReadForum(
          intval($existingRow['user_id']),
          intval($this->request->variable('forum_id', 0))
        );
        if ($access) return 'ACCESS|'.$this->getPermissionCheck()->addressingLimitForUser(intval($existingRow['user_id'])).'|'.(($this->getPermissionCheck()->canManageSubscriptions(intval($existingRow['user_id'])))?'m':'n');
        else return 'NO_ACCESS';
      } else return 'NOT_FOUND';
    } else if ($this->request->variable('group_name', '') != '') {
      $existingRow = $this->db->sql_fetchrow($this->db->sql_query('SELECT group_id FROM '.$this->table_prefix."groups WHERE group_name = '".$this->db->sql_escape(utf8_normalize_nfc($this->request->variable('group_name', '', true)))."'"));
      if ($existingRow) {
        $this->getPermissionCheck()->initAddressingPermissions($this->user->data['user_id'], array(), array(array(
          'gid' => intval($existingRow['group_id']),
          'name' => $this->request->variable('group_name', ''),
        )));
        if ($this->getPermissionCheck()->canAddressGroup(intval($existingRow['group_id']))) {
          $access = $this->getPermissionCheck()->groupCanReadForum(
            intval($existingRow['group_id']),
            intval($this->request->variable('forum_id', 0))
          );
          if ($access == 2) return 'ACCESS';
          else if ($access == 1) return 'PARTLY_ACCESS';
          else return 'NO_ACCESS';
        } else return 'NOT_ADDRESSABLE';
      } else return 'NOT_FOUND';
    } else return 'MISSING_PARAMETER';
  }

  public function handle () {
    $action = $this->request->variable('action', 'unknown');
    switch ($action) {
      case 'pgppublickey':
        return new \Symfony\Component\HttpFoundation\Response($this->getMailMessenger()->getPublicKey(), 200, [
          'Content-Disposition' => 'attachment; filename=ForumPublicKey.asc',
          'Content-Type' => 'text/plain',
        ]);

      case 'telegraminput':
        if (!$this->config['telegram_webhook_pass'])
          return new \Symfony\Component\HttpFoundation\Response('TELEGRAM_BRIDGE_DEACTIVATED', 403);
        $content = @file_get_contents('php://input');
        
          /*$myfile = fopen($this->phpbb_root_path.'ext/msta/emailontopic/tel.txt', "a") or die("Unable to open file!");
          $txt = "Post-Variables: ".join('|', $this->request->variable_names(\phpbb\request\request::POST))."\n";
          $txt .= "Get-Variables: ".join('|', $this->request->variable_names(\phpbb\request\request::GET))."\n";
          $txt .= "Post-body: ".$content."\n";
          fwrite($myfile, $txt);*/
          //return new \Symfony\Component\HttpFoundation\Response('SKIP', 200);
        
        $newPostId = 0;
        $telegramUser = '';
        $bridgeResult = $this->getTelegramBridge()->telegramInput(
          $content,
          $this->request->variable('pwd', ''),
          $newPostId,
          $telegramUser
        );
        if ($newPostId != 0) { // if a new post was created also sent message via email
          $row = $this->db->sql_fetchrow($this->db->sql_query('SELECT p.post_text, t.topic_title, p.forum_id, p.topic_id FROM '.$this->table_prefix.'posts AS p INNER JOIN '.$this->table_prefix.'topics AS t ON p.topic_id=t.topic_id WHERE p.post_id = '.intval($newPostId)));
          if ($row) {
            $message = $row['post_text'];
            $i = strrpos($message, '</telegramuser>');
            if ($i > 0) $message = substr($message, $i+15);
          }
        }
        return $bridgeResult;

      case 'mailnewerpostinfo':
        $lang = '';
        $accessCorrect = $this->getPermissionCheck()->mailAccessPwdTest(
          intval($this->request->variable('u', 0)),
          $this->request->variable('pwd', ''),
          $lang
        );
        $this->getMailMessenger()->postinfoimg(
          intval($this->request->variable('u', 0)),
          intval($this->request->variable('f', 0)),
          intval($this->request->variable('t', 0)),
          intval($this->request->variable('p', 0)),
          $lang,
          $accessCorrect,
          $this->getPermissionCheck()->userCanReadForum(intval($this->request->variable('u', 0)), intval($this->request->variable('f', 0)))
        );
        exit; // no return here as this would overwrite the image output

      case 'unsubscribe':
        $success = false;
        if ($this->getPermissionCheck()->mailAccessPwdTest(intval($this->request->variable('u', '')), $this->request->variable('pwd', ''))) {
          $this->getPermissionCheck()->setSubscription(
            intval($this->request->variable('u', '')),
            intval($this->request->variable('t', '')),
            0
          );
          $success = true;
        }
        return new \Symfony\Component\HttpFoundation\Response(($success)?'Unsubscribed':'Access denied', 200);

      case 'trigger':
        if (!$this->getPermissionCheck()->mailAccessPwdTest(intval($this->request->variable('u', '')), $this->request->variable('pwd', '')))
          return new \Symfony\Component\HttpFoundation\Response('Access denied', 200);
        $triggerResult = $this->phpbb_dispatcher->trigger_event('msta.emailontopic.mail_access_trigger', array(
          'user_id' => intval($this->request->variable('u', 0)),
          'post_id' => intval($this->request->variable('p', 0)),
          'trigger_name' => $this->request->variable('key', ''),
          'trigger_value' => $this->request->variable('val', ''),
          'result' => 'Trigger was called.',
        ));
        return new \Symfony\Component\HttpFoundation\Response($triggerResult['result'], 200);
    }
    if (!$this->user->data['is_registered'])
      return new \Symfony\Component\HttpFoundation\Response('!ACCESS_DENIED', 403);
    switch ($action) {
      case 'keepconnection':
        return new \Symfony\Component\HttpFoundation\Response('ONLINE', 200);
      case 'telegramdownload':
        if (!$this->config['telegram_webhook_pass'])
          return new \Symfony\Component\HttpFoundation\Response('TELEGRAM_BRIDGE_DEACTIVATED', 403);
        return $this->getTelegramBridge()->telegramDownloadForward($this->request->variable('fileid', ''));
      case 'setsubscription':
        $ok = $this->getPermissionCheck()->setSubscription(
          intval($this->user->data['user_id']),
          intval($this->request->variable('t', '')),
          intval($this->request->variable('subs', ''))
        );
        return new \Symfony\Component\HttpFoundation\Response((($ok)?'Subscriptions set':'!ERROR setting subscription'), 200);
      case 'availlablechannels':
        return $this->getTelegramBridge()->listAvaillableChannels();
      case 'search':
        return $this->getMailMessenger()->searchAvaillableReceivers($this->request->variable('name', ''));
      case 'checkpermission':
        return new \Symfony\Component\HttpFoundation\Response($this->permissionString(), 200);
    }
    return new \Symfony\Component\HttpFoundation\Response('!UNKNOWN_COMMAND', 200);
  }
}
