<?php

namespace msta\emailontopic\migrations;

class mig1 extends \phpbb\db\migration\migration {
  public function update_schema () {
    return array(
      'add_tables'  => array(
        $this->table_prefix.'group_mail_privileges' => array(
          'COLUMNS' => array(
            'from_group_id' => array('UINT', 0),
            'to_group_id' => array('UINT', 0),
            'user_recipient_count' => array('UINT:3', 0),
            'leader_recipient_count' => array('UINT:3', 0),
          ),
          'PRIMARY_KEY' => array('from_group_id', 'to_group_id'),
        ),
      ),
      'add_columns' => array(
        $this->table_prefix.'users' => array(
          'mail_visible_override' => array('UINT:1', 0),
          'mail_access_password' => array('VCHAR:12', ''),
        ),
        $this->table_prefix.'forums' => array(
          'bridging_security' => array('TINT:2', 0),
        ),
      ),
    );
  }

  public function revert_schema () {
    return array(
      'drop_tables'	=> array(
        $this->table_prefix.'group_mail_privileges',
      ),
      'drop_columns' => array(
        $this->table_prefix.'users' => array('mail_visible_override', 'mail_access_password'),
        $this->table_prefix.'forums' => array('bridging_security'),
      ),
    );
  }

  public function update_data () {
    return array(
      array('config.add', array('allow_mail_clear_content_default', 1)),
      array('custom', array(array($this, 'set_default_permissions'))),
      array('module.add', array(
        'acp',
        'ACP_CAT_DOT_MODS',
        'ACP_EMAILONTOPIC',
      )),
      array('module.add', array(
        'acp',
        'ACP_EMAILONTOPIC',
        array(
          'module_basename' => '\msta\emailontopic\acp\main_module',
          'modes' => array('group_settings'),
        ),
      )),
    );
  }

  public function revert_data () {
    return array(
      array('config.remove', array('allow_mail_clear_address_default')),
      array('config.remove', array('allow_mail_clear_content_default')),
      array('module.remove', array('acp', 0, 'ACP_EMAILONTOPIC')),
    );
  }

  public function set_default_permissions () {
    $this->sql_query('INSERT INTO '.$this->table_prefix.'group_mail_privileges(from_group_id, to_group_id, user_recipient_count, leader_recipient_count) VALUES (2, 2, 3, 0)');
  }
}
