<?php

namespace msta\emailontopic\migrations;

class mig2 extends \phpbb\db\migration\migration {
  static public function depends_on () {
    return array('\msta\emailontopic\migrations\mig1');
  }

  public function update_schema () {
    return array(
      'add_tables'  => array(
        $this->table_prefix.'telegram_links' => array(
          'COLUMNS' => array(
            'telegram_chat_id' => array('BINT', 0),
            'forum_link_id' => array('UINT:8', 0),
            'link_type' => array('TINT:1', 0),
            'chat_name' => array('VCHAR:40', ''),
            'join_date' => array('UINT:11', 0),
            'added_by' => array('BINT', 0),
            'active' => array('TINT:1', 1),
          ),
          'PRIMARY_KEY' => array('telegram_chat_id'),
        ),
        $this->table_prefix.'telegram_messages' => array(
          'COLUMNS' => array(
            'telegram_chat_id' => array('BINT', 0),
            'telegram_message_id' => array('INT:8', 0),
            'post_id' => array('UINT:8', 0),
          ),
          'PRIMARY_KEY' => array('telegram_chat_id, telegram_message_id'),
        ),
      ),
      'add_columns' => array(
        $this->table_prefix.'topics_watch' => array(
          'enduring' => array('TINT:1', 0),
        ),
        $this->table_prefix.'group_mail_privileges' => array(
          'subscription_management' => array('TINT:1', 0),
        ),
      ),
    );
  }

  public function revert_schema () {
    return array(
      'drop_tables'	=> array(
        $this->table_prefix.'telegram_links',
        $this->table_prefix.'telegram_messages',
      ),
    );
  }

  public function update_data () {
    return array(
      array('module.add', array(
        'acp',
        'ACP_EMAILONTOPIC',
        array(
          'module_basename' => '\msta\emailontopic\acp\main_module',
          'modes' => array('telegram_settings'),
        ),
      )),
    );
  }

  public function revert_data () {
    return array(
    );
  }
}
